/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by informer-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	time "time"

	openstackv1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	versioned "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-openstack/clientset/versioned"
	internalinterfaces "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-openstack/informers/externalversions/internalinterfaces"
	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-openstack/listers/openstack/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// OpenStackMachineInformer provides access to a shared informer and lister for
// OpenStackMachines.
type OpenStackMachineInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1beta1.OpenStackMachineLister
}

type openStackMachineInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewOpenStackMachineInformer constructs a new informer for OpenStackMachine type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewOpenStackMachineInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredOpenStackMachineInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredOpenStackMachineInformer constructs a new informer for OpenStackMachine type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredOpenStackMachineInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.InfrastructureV1beta1().OpenStackMachines(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.InfrastructureV1beta1().OpenStackMachines(namespace).Watch(context.TODO(), options)
			},
		},
		&openstackv1beta1.OpenStackMachine{},
		resyncPeriod,
		indexers,
	)
}

func (f *openStackMachineInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredOpenStackMachineInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *openStackMachineInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&openstackv1beta1.OpenStackMachine{}, f.defaultInformer)
}

func (f *openStackMachineInformer) Lister() v1beta1.OpenStackMachineLister {
	return v1beta1.NewOpenStackMachineLister(f.Informer().GetIndexer())
}
